%> @ingroup conversion classlabelsgroup
%> @file
%> @brief Inverse of @c classlabels2cell (limited)
%>
%> This function takes a cell generated by @ref classlabels2cell.m and converts it into a list of class labels (cell array).
%>
%> What it does is to return the unique elements of the third column of the argument, respecting their order of appearance.
%>
%> Please note that this function generates a set of class labels that matches the fourth column of the output of
%> @ref classlabels2cell.m
%>
%> @sa classlabels2cell.m
%
%> @param cc
%> @return \em classlabels
function out = cell2classlabels(cc)

out = {};

for i = 1:size(cc, 1)
    if ~any(find(strcmp(out, cc{i, 3})))
        out = [out, {cc{i, 3}}];
    end;
end;

